/* Este es codifica.c */

/* Transforma un binario a real*/
double decode (int tamano,int finx,double Inferior)
{  double xx=0.0;
  int i;

  for (i=0; i<tamano; i++)
    if (cromoBin[finx-i-1] == 1)
      xx = xx + pow ( 2.0, (double) i );
  return (xx);
}


/* convierte una cadena de codigo binaria a codigo de Gray*/
void BinGray(unsigned B[],unsigned G[])
{int k,i, aux, aux2;
  aux=0;
  for(i = 0; i < NumVar; i++){
    aux2=fin[i];
    G[aux] = B[aux];
    for(k = aux+1; k < aux2; k++)
      G[k] = B[k-1] ^ B[k];
    aux=aux2;
  }
}


/*Invierte el valor de n entero considerandolo como un binario*/
unsigned Not(unsigned x)
{
  int y;
  if(x) y = 0; else y = 1;
  return y;
}


/* Convierte una cadena de codigo de Gray a codigo binario*/
/* regresa el resultado en el arreglo B*/
void GrayBin(unsigned G[],unsigned B[])
{
  int k; unsigned val, aux, aux2,i;
  aux=0;
  for(i = 0; i < NumVar; i++){
    aux2 = fin[i];
    val = G[aux];
    B[aux] = val;
    for(k = aux+1; k < aux2; k++){
      if (G[k] == 1) val = Not(val);
      B[k] = val;
    }
    aux=aux2;
  }
}


double Limite (double X, int Lon, double LimSup, double LimInf)
{
  //X = LimInf + ((X * (LimSup-LimInf)) / (pow(2.0,Lon)-1.0));
    X = LimInf + ((X * (LimSup-LimInf)) /(double) (pow(2.0,Lon)-1));
  return (X);
}


/* Normaliza la aptitud para invertir el plano de porcentajes Problema 2*/
double Normaliza(double x)
{
  /* P varia segun el la complejidad de las variables*/
  long P = precision;
  return( (1/x)*P );
}
